

#include "def_vst.h"

MAIN
{
    float f,
          s,
          o,
          lcnt, /* line counter */
          dlcnt;
    bool  Nopt;

    static char *synopsis = 
"~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n"
"                                     V1.2, 12.6.1992,  V.Strom \n"
"                                                               \n"
" usage:  ftoa   < f4_sig  >  gnudat                            \n"
"                                                               \n"
" i4_sig     binary floats                                      \n"
" gnudat     gnuplot data file (ASCII), first column x value,   \n"
"            2nd column scaled short integer                    \n"
"                                                               \n"
" ftoa converts floats into ASCII for gnuplot.                  \n"
" The x values start at 0 and increase by 1 every output line   \n"
" by default.                                                   \n"
"                                                               \n"
" OPTIONS:                                                      \n"
"                                                               \n"
"    -s scale   (float, default = 1)                            \n"
"    -o offset  (float, default = 0)                            \n"
"                                                               \n"
"    Given the float f, output in the 2nd column is             \n"
"    (f*s)+o.                                                   \n"
"                                                               \n"
"    -f x0      (float, default = 0)                            \n"
"    -d dx      (float, default = 1)                            \n"
"                                                               \n"
"    The x values start with x0 and increase dx every output    \n"
"    line.                                                      \n"
"                                                               \n"
"    -N  do not output x values.                                \n"
"                                                               \n"
" See also atof, itoa, atoi.                                    \n"
"                                                               \n"
"                                                               \n"
"~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n";
    ARGS(0,"N","sofd");

    FOPT('s', s, 1);
    FOPT('o', o, 0);
    FOPT('f', lcnt, 0);
    FOPT('d',dlcnt, 1);
    BOPT('N',Nopt);

    while(FREAD(&f,float,EXACTLY,1,stdin)==1)
    {   if(Nopt)
            fprintf(stdout,"%g\n", (float)(f*s+o));
        else
            fprintf(stdout,"%f\t%g\n", lcnt, (float)(f*s+o));
        lcnt += dlcnt;

        #ifdef FWRITE_IMMEDIATELY
            fflush(stdout);
        #endif
    }

    return 0;
}   

